space_constitution_rep< T, M >

## Public Types

typedef space_constitution_rep< T, M > | this_type
typedef space_constitution< T, M > | value_type
typedef std::vector< value_type > | hierarchy_type
typedef space_scalar_constitution< T, M > | scalar_type
typedef hierarchy_type::size_type | size_type
typedef hierarchy_type::iterator | iterator
typedef hierarchy_type::const_iterator | const_iterator
typedef space_constant::valued_type | valued_type

## Public Member Functions

| space_constitution_rep ()
| space_constitution_rep (const space_constitution_rep< T, M > &x)
| space_constitution_rep (const geo_basic< T, M > &omega, std::string approx)
| space_constitution_rep (const space_mult_list< T, M > &)
const distributor & | ownership () const
std::string | name () const
size_type | ndof () const
size_type | dis_ndof () const
communicator | comm () const
size_type | ios_ndof () const
void | do_act (const space_act &act)
const geo_basic< T, M > & | get_geo () const
const geo_basic< T, M > & | get_background_geo () const
const basis_basic< T > & | get_basis () const
size_type | loc_ndof (const reference_element &hat_K) const
size_type | assembly_loc_ndof (const geo_basic< T, M > &dom, const geo_element &bgd_K) const
void | assembly_dis_idof (const geo_basic< T, M > &dom, const geo_element &bgd_K, std::vector< geo_element::size_type > &dis_idof) const
void | compute_external_dofs (std::set< size_type > &ext_dof_set) const
void | set_valued_tag (valued_type valued_tag)
void | set_valued (const std::string &valued)
const valued_type & | valued_tag () const
const std::string & | valued () const
bool | is_hierarchical () const
void | set_hierarchy (bool hier)
bool | have_compact_support_inside_element () const
bool | is_discontinuous () const
size_type | degree_max () const
void | neighbour_guard () const
const scalar_type & | get_scalar () const
scalar_type & | get_scalar ()
const hierarchy_type & | get_hierarchy () const
hierarchy_type & | get_hierarchy ()
size_type | size () const
space_constitution< T, M > & | operator[] (size_type i_comp)
const space_constitution< T, M > & | operator[] (size_type i_comp) const
size_type | flattened_size () const
void | set_ios_permutations (disarray< size_type, M > &idof2ios_dis_idof, disarray< size_type, M > &ios_idof2dis_idof) const
bool | operator== (const space_constitution_rep< T, M > &V2) const
void | initialize () const
void | append_external_dof (const geo_basic< T, M > &dom, std::set< size_type > &ext_dof_set, const distributor &dof_ownership, const distributor &start_by_component) const
void | compute_external_dofs (std::set< size_type > &ext_dof_set, const distributor &dof_ownership, const std::vector< distributor > &start_by_component, size_type &i_comp) const
void | build_blocked_flag_recursive (disarray< size_type, M > &blocked_flag, const std::vector< distributor > &start_by_component, size_type &i_comp) const
disarray< size_type, M > | build_blocked_flag () const
void | put (std::ostream &out, size_type level=0) const

## Protected Member Functions

void | hierarchy_guard () const
void | scalar_guard () const
void | set_ios_permutation_recursion (disarray< size_type, M > &idof2ios_dis_idof, size_type &comp_start_idof, size_type &comp_start_dis_idof) const
size_type | _init_flattened_size () const
void | _init_start_by_flattened_component (size_type &i_flat_comp, size_type &start_flat_comp_idof, size_type &dis_start_flat_comp_idof, std::vector< distributor > &start_by_flattened_component) const
void | _init_start_by_component () const
void | _assembly_dis_idof_recursive (const geo_basic< T, M > &dom, const geo_element &bgd_K, typename std::vector< geo_element::size_type >::iterator &dis_idof_t, const distributor &hier_ownership, const std::vector< distributor > &start_by_flattened_component, size_type &i_flat_comp) const

## Protected Attributes

bool | _is_initialized
size_type | _flattened_size
std::vector< distributor > | _start_by_flattened_component
std::vector< distributor > | _start_by_component
distributor | _ownership
valued_type | _valued_tag
bool | _is_hier
scalar_type | _scalar_constit
hierarchy_type | _hier_constit
std::array< size_type, reference_element::max_variant > | _loc_ndof

## Detailed Description

### template<class T, class M>
class rheolef::space_constitution_rep< T, M >

Definition at line 208 of file space_constitution.h.

## Member Typedef Documentation

## this_type

typedef space_constitution_rep<T,M> this_type

Definition at line 210 of file space_constitution.h.

## value_type

typedef space_constitution<T,M> value_type

Definition at line 211 of file space_constitution.h.

## hierarchy_type

typedef std::vector<value_type> hierarchy_type

Definition at line 212 of file space_constitution.h.

## scalar_type

typedef space_scalar_constitution<T,M> scalar_type

Definition at line 213 of file space_constitution.h.

## size_type

typedef hierarchy_type::size_type size_type

Definition at line 214 of file space_constitution.h.

## iterator

typedef hierarchy_type::iterator iterator

Definition at line 215 of file space_constitution.h.

## const_iterator

typedef hierarchy_type::const_iterator const_iterator

Definition at line 216 of file space_constitution.h.

## valued_type

typedef space_constant::valued_type valued_type

Definition at line 217 of file space_constitution.h.

## Constructor & Destructor Documentation

## space_constitution_rep() [1/4]

space_constitution_rep

Definition at line 346 of file space_constitution.h.

## space_constitution_rep() [2/4]

space_constitution_rep | ( | const space_constitution_rep< T, M > & | x | ) |

Definition at line 362 of file space_constitution.h.

## space_constitution_rep() [3/4]

space_constitution_rep | ( | const geo_basic< T, M > & | omega,
|  | std::string | approx
| ) |  |

Definition at line 283 of file space_constitution.cc.

## space_constitution_rep() [4/4]

space_constitution_rep | ( | const space_mult_list< T, M > & | expr | ) |

Definition at line 306 of file space_constitution.cc.

## Member Function Documentation

## ownership()

const distributor& ownership | ( |  | ) | const

Definition at line 228 of file space_constitution.h.

## name()

std::string name

Definition at line 531 of file space_constitution.cc.

## ndof()

size_type ndof | ( |  | ) | const

Definition at line 230 of file space_constitution.h.

## dis_ndof()

size_type dis_ndof | ( |  | ) | const

Definition at line 231 of file space_constitution.h.

## comm()

communicator comm | ( |  | ) | const

Definition at line 232 of file space_constitution.h.

## ios_ndof()

space_constitution_rep< T, M >::size_type ios_ndof

Definition at line 575 of file space_constitution.cc.

## do_act()

void do_act | ( | const space_act & | act | ) |

Definition at line 84 of file space_constitution.cc.

## get_geo()

const geo_basic< T, M > & get_geo

Definition at line 208 of file space_constitution.cc.

## get_background_geo()

const geo_basic< T, M > & get_background_geo

Definition at line 233 of file space_constitution.cc.

## get_basis()

const basis_basic< T > & get_basis

Definition at line 246 of file space_constitution.cc.

## loc_ndof()

space_constitution_rep< T, M >::size_type loc_ndof | ( | const reference_element & | hat_K | ) | const

Definition at line 43 of file space_constitution_assembly.cc.

## assembly_loc_ndof()

space_constitution_rep< T, M >::size_type assembly_loc_ndof | ( | const geo_basic< T, M > & | dom,
|  | const geo_element & | bgd_K
| ) |  | const

Definition at line 137 of file space_constitution_assembly.cc.

## assembly_dis_idof()

void assembly_dis_idof | ( | const geo_basic< T, M > & | dom,
|  | const geo_element & | bgd_K,
|  | std::vector< geo_element::size_type > & | dis_idof
| ) |  | const

Definition at line 344 of file space_constitution_assembly.cc.

## compute_external_dofs() [1/2]

void compute_external_dofs | ( | std::set< size_type > & | ext_dof_set | ) | const

Definition at line 500 of file space_constitution.cc.

## set_valued_tag()

void set_valued_tag | ( | valued_type | valued_tag | ) |

Definition at line 243 of file space_constitution.h.

## set_valued()

void set_valued | ( | const std::string & | valued | ) |

Definition at line 244 of file space_constitution.h.

## valued_tag()

const valued_type& valued_tag | ( |  | ) | const

Definition at line 245 of file space_constitution.h.

## valued()

const std::string& valued | ( |  | ) | const

Definition at line 246 of file space_constitution.h.

## is_hierarchical()

bool is_hierarchical | ( |  | ) | const

Definition at line 247 of file space_constitution.h.

## set_hierarchy()

void set_hierarchy | ( | bool | hier | ) |

Definition at line 248 of file space_constitution.h.

## have_compact_support_inside_element()

bool have_compact_support_inside_element

Definition at line 256 of file space_constitution.cc.

## is_discontinuous()

bool is_discontinuous

Definition at line 270 of file space_constitution.cc.

## degree_max()

space_constitution_rep< T, M >::size_type degree_max

Definition at line 542 of file space_constitution.cc.

## neighbour_guard()

void neighbour_guard

Definition at line 556 of file space_constitution.cc.

## get_scalar() [1/2]

const scalar_type& get_scalar | ( |  | ) | const

Definition at line 259 of file space_constitution.h.

## get_scalar() [2/2]

scalar_type& get_scalar | ( |  | ) |

Definition at line 260 of file space_constitution.h.

## get_hierarchy() [1/2]

const hierarchy_type& get_hierarchy | ( |  | ) | const

Definition at line 264 of file space_constitution.h.

## get_hierarchy() [2/2]

hierarchy_type& get_hierarchy | ( |  | ) |

Definition at line 265 of file space_constitution.h.

## size()

size_type size | ( |  | ) | const

Definition at line 266 of file space_constitution.h.

## operator[]() [1/2]

space_constitution<T,M>& operator[] | ( | size_type | i_comp | ) |

Definition at line 267 of file space_constitution.h.

## operator[]() [2/2]

const space_constitution<T,M>& operator[] | ( | size_type | i_comp | ) | const

Definition at line 268 of file space_constitution.h.

## flattened_size()

size_type flattened_size | ( |  | ) | const

Definition at line 270 of file space_constitution.h.

## set_ios_permutations()

void set_ios_permutations | ( | disarray< size_type, M > & | idof2ios_dis_idof,
|  | disarray< size_type, M > & | ios_idof2dis_idof
| ) |  | const

Definition at line 638 of file space_constitution.cc.

## operator==()

bool operator== | ( | const space_constitution_rep< T, M > & | V2 | ) | const

Definition at line 328 of file space_constitution.cc.

## initialize()

void initialize

Definition at line 403 of file space_constitution.cc.

## append_external_dof()

void append_external_dof | ( | const geo_basic< T, M > & | dom,
|  | std::set< size_type > & | ext_dof_set,
|  | const distributor & | dof_ownership,
|  | const distributor & | start_by_component
| ) |  | const

Definition at line 451 of file space_constitution.cc.

## compute_external_dofs() [2/2]

void compute_external_dofs | ( | std::set< size_type > & | ext_dof_set,
|  | const distributor & | dof_ownership,
|  | const std::vector< distributor > & | start_by_component,
|  | size_type & | i_comp
| ) |  | const

Definition at line 481 of file space_constitution.cc.

## build_blocked_flag_recursive()

void build_blocked_flag_recursive | ( | disarray< size_type, M > & | blocked_flag,
|  | const std::vector< distributor > & | start_by_component,
|  | size_type & | i_comp
| ) |  | const

Definition at line 176 of file space_constitution.cc.

## build_blocked_flag()

disarray< typename space_constitution_rep< T, M >::size_type, M > build_blocked_flag

Definition at line 195 of file space_constitution.cc.

## put()

void put | ( | std::ostream & | out,
|  | size_type | level = `0`
| ) |  | const

Definition at line 512 of file space_constitution.cc.

## hierarchy_guard()

void hierarchy_guard | ( |  | ) | const

protected

Definition at line 306 of file space_constitution.h.

## scalar_guard()

void scalar_guard | ( |  | ) | const

protected

Definition at line 307 of file space_constitution.h.

## set_ios_permutation_recursion()

void set_ios_permutation_recursion | ( | disarray< size_type, M > & | idof2ios_dis_idof,
|  | size_type & | comp_start_idof,
|  | size_type & | comp_start_dis_idof
| ) |  | const

protected

Definition at line 601 of file space_constitution.cc.

## _init_flattened_size()

space_constitution_rep< T, M >::size_type _init_flattened_size

protected

Definition at line 346 of file space_constitution.cc.

## _init_start_by_flattened_component()

void _init_start_by_flattened_component | ( | size_type & | i_flat_comp,
|  | size_type & | start_flat_comp_idof,
|  | size_type & | dis_start_flat_comp_idof,
|  | std::vector< distributor > & | start_by_flattened_component
| ) |  | const

protected

Definition at line 358 of file space_constitution.cc.

## _init_start_by_component()

void _init_start_by_component

protected

Definition at line 382 of file space_constitution.cc.

## _assembly_dis_idof_recursive()

void _assembly_dis_idof_recursive | ( | const geo_basic< T, M > & | dom,
|  | const geo_element & | bgd_K,
|  | typename std::vector< geo_element::size_type >::iterator & | dis_idof_t,
|  | const distributor & | hier_ownership,
|  | const std::vector< distributor > & | start_by_flattened_component,
|  | size_type & | i_flat_comp
| ) |  | const

protected

Definition at line 223 of file space_constitution_assembly.cc.

## Member Data Documentation

## _is_initialized

bool _is_initialized

mutable protected

Definition at line 329 of file space_constitution.h.

## _flattened_size

size_type _flattened_size

mutable protected

Definition at line 330 of file space_constitution.h.

## _start_by_flattened_component

std::vector<distributor> _start_by_flattened_component

mutable protected

Definition at line 331 of file space_constitution.h.

## _start_by_component

std::vector<distributor> _start_by_component

mutable protected

Definition at line 332 of file space_constitution.h.

## _ownership

distributor _ownership

mutable protected

Definition at line 333 of file space_constitution.h.

## _valued_tag

valued_type _valued_tag

protected

Definition at line 334 of file space_constitution.h.

## _is_hier

bool _is_hier

protected

Definition at line 335 of file space_constitution.h.

## _scalar_constit

scalar_type _scalar_constit

protected

Definition at line 336 of file space_constitution.h.

## _hier_constit

hierarchy_type _hier_constit

protected

Definition at line 337 of file space_constitution.h.

## _loc_ndof

std::array<size_type, reference_element::max_variant> _loc_ndof

mutable protected

Definition at line 338 of file space_constitution.h.

The documentation for this class was generated from the following files:

- /build/rheolef-bzr82u/rheolef-7.1/main/lib/space_constitution.h
- /build/rheolef-bzr82u/rheolef-7.1/main/lib/space_constitution.cc
- /build/rheolef-bzr82u/rheolef-7.1/main/lib/space_constitution_assembly.cc